{$I DEFINES.INC}
UNIT MYCRT;{

              
            
               ͻ ͻ ͻ    ͻ ͻ
                    ˼ ͹ ͼ ͹     ͻ
                   ͼ          ͼ ͼ

  The MAX Graphics GUI kit is Copyright 1995-Current Larry L. Athey (LA-Soft).
  BMP Color Averaging procedure is courtesy of Sean Price (Rude Dog Software).
}

INTERFACE

CONST
  CheckBreak : BOOLEAN = TRUE;
  TextAttr   : BYTE    = $07;

PROCEDURE CLRSCR;
FUNCTION  KEYPRESSED : BOOLEAN;
FUNCTION  READKEY : CHAR;
PROCEDURE GOTOXY(X,Y : BYTE);
FUNCTION  WHEREX : BYTE;
FUNCTION  WHEREY : BYTE;
PROCEDURE SOUND(Hertz : WORD);
PROCEDURE NOSOUND;
{--------------------------Special NON-CRT Routines-------------------------}
PROCEDURE OutTextXY(X,Y,F,B : BYTE; S : STRING);
PROCEDURE HideCursor;
PROCEDURE ShowCursor;
{---------------------------------------------------------------------------}
IMPLEMENTATION

USES DOS;

CONST
  DVseg : WORD = $B800;
  DVofs : WORD = $0000;

{}
PROCEDURE CLRSCR;
BEGIN
  INLINE($B4 / $06 / $B0 / $19 / $B7 / $07 / $B5 / $00 / $B1 / $00 / $B6 / $19 / $B2 /
         $4F / $CD / $10 / $B4 / $02 / $B7 / $00 / $B2 / $00 / $B6 / $00 / $CD / $10);
END;
{}
FUNCTION KEYPRESSED : BOOLEAN;
VAR
  IsThere : BYTE;
BEGIN
  INLINE($B4 / $0B / $CD / $21 / $88 / $86 / > IsThere);
  KEYPRESSED := (IsThere = $FF);
END;
{}
FUNCTION READKEY : CHAR;
VAR
  ChrOut : CHAR;
BEGIN
  INLINE($B4 / $07 / $CD / $21 / $88 / $86 / > ChrOut);
  IF CheckBreak AND (ChrOut = #3) THEN INLINE($CD / $23);
  READKEY := ChrOut;
END;
{}
PROCEDURE GOTOXY(X,Y : BYTE); Assembler;
ASM
  MOV  DH,Y
  MOV  DL,X
  DEC  DH
  DEC  DL
  MOV  BH,0
  MOV  AH,2
  INT  10h
END;
{}
FUNCTION WHEREX : BYTE; Assembler;
ASM
  MOV  AH,3
  MOV  BH,0
  INT  10h
  INC  DL
  MOV  AL,DL
END;
{}
FUNCTION WHEREY : BYTE; Assembler;
ASM
  MOV  AH,3
  MOV  BH,0
  INT  10h
  INC  DH
  MOV  AL,DH
END;
{}
PROCEDURE SOUND(Hertz : WORD); Assembler;
ASM
  MOV  BX,SP
  MOV  BX,&Hertz
  MOV  AX,34DDh
  MOV  DX,0012h
  CMP  DX,BX
  JNB  @J1
  DIV  BX
  MOV  BX,AX
  IN   AL,61h
  TEST AL,03h
  JNZ  @J2
  OR   AL,03h
  OUT  61h,AL
  MOV  AL, - 4Ah
  OUT  43h,AL
@J2 :
  MOV  AL,BL
  OUT  42h,AL
  MOV  AL,BH
  OUT  42h,AL
@J1 :
END;
{}
PROCEDURE NOSOUND; Assembler;
ASM
  IN   AL,61h
  AND  AL,0FCh
  OUT  61h,AL
END;
{}
PROCEDURE DVWrite(X,Y : WORD ; Attr : BYTE; S : STRING); Assembler;
ASM
  PUSH DS
  MOV  BX,[Y]
  DEC  BX
  SHL  BX,1
  MOV  AX,BX
{$IFOPT G+}
  SHL  BX,2
{$ELSE}
  SHL  BX,1
  SHL  BX,1
{$ENDIF}
  ADD  AX,BX
  ADD  AX,[DVseg]
  MOV  ES,AX
  MOV  DI,[X]
  DEC  DI
  SHL  DI,1
  ADD  DI,[DVofs]
  LDS  SI,S
  MOV  CL,BYTE PTR [SI]
  INC  SI
  MOV  AH,Attr
@1 :
  MOV  AL,BYTE PTR [SI]
  MOV  WORD PTR ES : [DI],AX
  INC  SI
  ADD  DI,2
  DEC  CL
  JNZ  @1
  POP  DS
END;
{}
PROCEDURE OutTextXY(X,Y,F,B : BYTE; S : STRING);
BEGIN
  DVWrite(X,Y,(B * 16) + F,S);
END;
{}
PROCEDURE HideCursor; Assembler;
ASM
  MOV  AX,$0100
  MOV  CX,$2607
  INT  $10
END;
{}
PROCEDURE ShowCursor; Assembler;
ASM
  MOV  AX,$0100
  MOV  CX,$0506
  INT  $10
END;
{}
BEGIN

END.
