{$I DEFINES.INC}
{.$A+,B-,D+,E+,F+,G+,I-,L+,N-,O+,P-,Q-,R-,S-,T-,V+,X+}
UNIT TERMVARS;

INTERFACE

{.$DEFINE InternalComp}

TYPE Dialing_Directory = RECORD      {Record for each phone book entry       }
     BBSname           : STRING[30]; {The name of the BBS                    }
     PhoneNumber       : STRING[30]; {The BBS phone number                   }
     UseMAX            : BOOLEAN;    {Use MAX Graphics [Y/N]                 }
     BoardID           : STRING[8];  {File name for PKG resource file        }
     AnsiMode          : BYTE;       {1=Text Mode ANSI, 2=Graphical ANSI     }
     UseSB             : BOOLEAN;    {Use SoundBlaster [Y/N]                 }
     UserName          : STRING[30]; {The user's name for auto-logon         }
     PassWord          : STRING[30]; {The user's password for auto-logon     }
     PreInit           : STRING[30]; {Pre ATDT modem initialization string   }
     END;

TYPE Misc_Information  = RECORD      {Record for miscellaneous settings      }
     UpPath            : STRING[40]; {Default upload path                    }
     DownPath          : STRING[40]; {Download path                          }
     ArcPath           : STRING[40]; {Path to archiver programs              }
     DefaultArc        : BYTE;       {1=ZIP, 2=LHA, 3=ARJ, 4=RAR, 5=Custom   }
     ArcBAT            : STRING[40]; {Custom archiver batch file             }
     UnArcBAT          : STRING[40]; {Custom unarchiver batch file           }
     UpProto           : STRING[40]; {Custom upload protocol batch file      }
     DownProto         : STRING[40]; {Custom download protocol batch file    }
     Retries           : BYTE;       {How many times to try to call a BBS    }
     RetryDelay        : BYTE;       {Seconds between call retries           }
     EditorPKG         : STRING[8];  {Default PKG for screen file viewer     }
     END;

TYPE SB_Information    = RECORD
     IRQ               : STRING[2];  {Sound card port IRQ.                   }
     DMA               : STRING[2];  {Sound card DMA channel.                }
     Address           : STRING[3];  {Sound card port address with no "$".   }
     END;

CONST
  Copyright = 'Copyright 1995-Current  Larry L. Athey  BBS Utiliteez Software';

VAR
  Misc        : Misc_Information;
  DD          : Dialing_Directory;
  SB          : SB_Information;
  DialMode    : BYTE;
  QueueSize   : BYTE;
  AutoMode    : BOOLEAN;
  DebugOn     : BOOLEAN;
  MAXmode     : BOOLEAN;
  FullMAX     : BOOLEAN;
  RIPfake     : BOOLEAN;
  TextActive  : BOOLEAN;
  MouseOn     : BOOLEAN;
  MaxID       : STRING[4];
  LastPKG     : STRING[8];
  HomeDir     : STRING[68];

IMPLEMENTATION

END.
