{$I DEFINES.INC}
{.$A+,B-,D+,E+,F+,G+,I-,L+,N-,O+,P-,Q-,R-,S-,T-,V+,X+}
UNIT TRMUNIT2;

INTERFACE

PROCEDURE TerminalMode;

IMPLEMENTATION

USES MYCRT, FGMAIN, GUI_UNIT, GUI_UTIL, GUI_ANSI, GUI_FONT,
    _SCRIPT, TRMUNIT3, TRMUNIT4, TERMVARS, APVARS, ANSIUNIT,
     MOD_UNIT, _PROTO, _PROTO2, PORTUNIT;


FUNCTION HangUpOkay : BOOLEAN;
BEGIN
  IF TextActive THEN HangUpOkay := HangUpOkay1 ELSE HangUpOkay := HangUpOkay2;
END;

FUNCTION ExitOkay : BOOLEAN;
BEGIN
  IF TextActive THEN ExitOkay := ExitOkay1 ELSE ExitOkay := ExitOkay2;
END;

PROCEDURE TerminalMode;
VAR
  Finished : BOOLEAN;
  ButNum   : BYTE;

PROCEDURE AnsiWindow;
BEGIN
  IF NOT DebugOn THEN BEGIN
    ScreenDone := FALSE;
    IF WindowNumber > 2 THEN REPEAT Kill_Window UNTIL WindowNumber = 2;
    UnloadGemFont(FPtr);
    Show_Mem;
    IF (MouseOn) OR (NOT Carrier) THEN BEGIN
      HideMouse;
      MouseOn := FALSE;
    END;
    IF DD.AnsiMode = 1 THEN BEGIN
      ShutDownSvga;
      StartUpTextTerminal;
    END ELSE BEGIN
      Draw_Window(0,0,639,439,2,'');
      AnsiFullScreen;
    END;
  END;
  MAXmode := FALSE;
  ScrStr  := '';
END;

BEGIN
  ExplodeOn  := FALSE;
  Finished   := FALSE;
  MouseOn    := FALSE;
  CursorOn   := FALSE;
  TextActive := NOT SVGAmode;
  RipFake    := DD.UseMax;
  ScrStr     := '';
  DownPath1  := Misc.DownPath;
  DownPath2  := Misc.DownPath;
  WriteSystemInfo;
  REPEAT
   {Process characters to send}
    ButNum := 0;
    IF ScreenDone THEN BEGIN
      IF NOT MouseOn THEN BEGIN
        ShowMouse;
        MouseOn := TRUE;
        ScrStr  := '';
      END;
    END;
    IF MouseOn THEN BEGIN
      IF DataAvailable THEN MC := #255 ELSE ButNum := MouseHandler(TRUE);
      IF (ButNum <> 0) AND (NButtons <> 0) AND (NOT PickInfo.Active) AND (NOT TextReader.Active) THEN BEGIN
        MC := CHR(Buttons^[ButNum].Return);
        IF (AltKey) AND (NOT (MC IN [#59..#68])) THEN BEGIN
          SendChar(MC);
          IF Buttons^[ButNum].ButStr <> #0 THEN BEGIN
            Buttons^[ButNum].ButStr := CvtExt(Buttons^[ButNum].ButStr);
            SendStr(Buttons^[ButNum].ButStr);
          END;
          IF Buttons^[ButNum].Sound <> #0 THEN PlayButtonSound(Buttons^[ButNum].Sound);
          AltKey := FALSE;
          MC     := #255;
        END;
      END;
      IF (ButNum > 2) AND (NButtons <> 0) AND ((PickInfo.Active) OR (TextReader.Active)) THEN BEGIN
        MC := CHR(Buttons^[ButNum].Return);
        IF (AltKey) AND (NOT (MC IN [#59..#68])) THEN BEGIN
          SendChar(MC);
          IF Buttons^[ButNum].ButStr <> #0 THEN BEGIN
            Buttons^[ButNum].ButStr := CvtExt(Buttons^[ButNum].ButStr);
            SendStr(Buttons^[ButNum].ButStr);
          END;
          IF Buttons^[ButNum].Sound <> #0 THEN PlayButtonSound(Buttons^[ButNum].Sound);
          AltKey := FALSE;
          MC     := #255;
        END;
      END;
    END ELSE BEGIN
      IF NOT DataAvailable THEN TimeSlice;
    END;
    IF (TextEditor.Active) AND (TextEditor.Done) THEN BEGIN
      SendChar(#13);
      TextEditor.Done := FALSE;
    END;
    IF TvPort.Active THEN BEGIN
      IF (NOT CursorOn) AND (NOT DataAvailable) THEN BEGIN
        Gui_Ansi.PlaceCursor;
        CursorOn := TRUE;
      END;
    END;
    IF (KEYPRESSED) OR (MouseOn) THEN BEGIN
      IF (SendLocalAltKeys) AND (NOT MouseOn) THEN BEGIN
        AltKey := FALSE;
        MC     := READKEY;
        IF MC = #0 THEN AltKey := TRUE;
      END;
      IF AltKey THEN BEGIN
        IF (SendLocalAltKeys) AND (NOT MouseOn) THEN MC := READKEY;
        CASE MC OF
          {-----User Function Keys-----}
          #59 : IF TextActive THEN Mode1Menu ELSE Mode2Menu;
          #60 : IF DD.UseMAX THEN BEGIN
                  RIPfake := NOT RIPfake;
                  IF NOT TextActive THEN BEGIN
                    FG_SetColor(C.ButtonFace);
                    FG_Rect(560,637,3,18);
                    IF RIPfake THEN ShadowText(560,2,15,0,2,'RIP Fake: ON')
                               ELSE ShadowText(560,2,15,0,2,'RIP Fake: OFF');
                  END ELSE BEGIN
                    ShowFakeStatus;
                  END;
                END;
          #61 : IF HangUpOkay THEN BEGIN
                  IF Carrier THEN BEGIN
                    ClearModem;
                    HangUp;
                  END;
                  IF MAXmode THEN AnsiWindow;
                  IF TextActive THEN WRITELN(ModemResult) ELSE Display_ANSIstr(ModemResult);
                END;
          #62 : IF ExitOkay THEN Finished := TRUE;
          #63 : IF TextActive THEN Mode1ULQ ELSE Mode2ULQ;
          #64 : IF TextActive THEN Mode1Download ELSE Mode2Download;
          #65 : IF TextActive THEN AsciiUpload1 ELSE AsciiUpload2;
          #66 : BEGIN
                  IF ModPlaying THEN ModShutDown;
                  IF TextActive THEN DOSshell1 ELSE DOSshell2;
                END;
          #67 : SendStr(DD.UserName + #13);
          #68 : SendStr(DD.PassWord + #13);
          {-----Cursor Control Keys-----}
          #71 : IF SendLocalAltKeys THEN SendStr(#27'[H') ELSE MC := #255;
          #72 : IF SendLocalAltKeys THEN SendStr(#27'[A') ELSE MC := #255;
          #75 : IF SendLocalAltKeys THEN SendStr(#27'[D') ELSE MC := #255;
          #77 : IF SendLocalAltKeys THEN SendStr(#27'[C') ELSE MC := #255;
          #79 : IF SendLocalAltKeys THEN SendStr(#27'[K') ELSE MC := #255;
          #80 : IF SendLocalAltKeys THEN SendStr(#27'[B') ELSE MC := #255;
          #82 : IF SendLocalAltKeys THEN SendChar(#22) ELSE MC := #255;
          #83 : IF SendLocalAltKeys THEN SendChar(#127) ELSE MC := #255;
        END;
      END ELSE IF MC <> #255 THEN BEGIN
        SendChar(MC);
        IF (ButNum <> 0) AND (NButtons <> 0) AND (NOT AltKey) AND (Buttons^[ButNum].ButStr <> #0) THEN BEGIN
          Buttons^[ButNum].ButStr := CvtExt(Buttons^[ButNum].ButStr);
          SendStr(Buttons^[ButNum].ButStr);
        END;
        IF (ButNum <> 0) AND (NButtons <> 0) AND
           (NOT AltKey) AND (Buttons^[ButNum].Sound <> #0) THEN PlayButtonSound(Buttons^[ButNum].Sound);
      END;
    END;
   {Process characters received}
    IF (DataAvailable) AND (NOT Finished) THEN BEGIN
      IF TvPort.Active THEN BEGIN
        IF CursorOn THEN BEGIN
          EraseCursor;
          CursorOn := FALSE;
        END;
      END;
      MC := ReadChar;
      IF LENGTH(ScrStr) > 254 THEN DELETE(ScrStr,1,1);
      ScrStr := ScrStr + MC;
      IF POS('[6n',ScrStr) > 0 THEN BEGIN
        IF DD.AnsiMode = 1 THEN SendStr('[24;1R') ELSE SendStr('[25;1R');
        IF DebugOn THEN OutTextXY(1,24,14,0,PadRight('Host requested screen length report.',' ',79));
        ScrStr := '';
      END;
      IF POS('**EMSI_REQ',ScrStr) > 0 THEN BEGIN
        SendStr('');
        ScrStr := '';
      END ELSE
      IF POS('rz'#13,ScrStr) > 0 THEN BEGIN
        ClearModem;
        IF TextActive THEN _Proto.ReceiveFiles(DownPath1,1) ELSE _Proto2.ReceiveFiles(DownPath1,1);
        IF NOT MouseOn THEN HideMouse;
        IF FExist(Misc.DownPath + 'MXT.RES') THEN CopyFile('SYSTEM.NFO','UPDATE.FLG');
        ScrStr := '';
      END ELSE
      IF POS(#1'rm'#13,ScrStr) > 0 THEN BEGIN
        ClearModem;
        IF TextActive THEN _Proto.ReceiveFiles(DownPath1,6) ELSE _Proto2.ReceiveFiles(DownPath1,6);
        IF NOT MouseOn THEN HideMouse;
        IF FExist(Misc.DownPath + 'MXT.RES') THEN CopyFile('SYSTEM.NFO','UPDATE.FLG');
        ScrStr := '';
      END;
      IF DD.UseMAX THEN BEGIN
        IF ((POS('[!',ScrStr) > 0) OR (POS('[0!',ScrStr) > 0)) AND (RIPfake) THEN BEGIN
          SendStr('RIPSCRIP015400');
          IF DebugOn THEN OutTextXY(1,24,12,0,PadRight('Host requested RIP compatibility report.',' ',79));
          ScrStr := '';
        END;
        IF (POS('!|1F',ScrStr) > 0) AND (RIPfake) THEN BEGIN
          SendStr('1' + #13);
          IF DebugOn THEN OutTextXY(1,24,12,0,PadRight('Host sent a RIP icon query command.',' ',79));
          ScrStr := '';
        END;
        IF POS('~',ScrStr) > 0 THEN BEGIN
          SendStr(MaxID);
          FullMax := TRUE;
          IF DebugOn THEN OutTextXY(1,24,10,0,PadRight('Host requested MAX compatibility report.',' ',79));
          ScrStr  := '';
        END;
        IF (MAXmode) AND (NOT Carrier) THEN AnsiWindow;
        IF (NOT Carrier) AND (QueueSize <> 0) THEN Finished := TRUE;
        IF (MAXmode) AND
           ((POS('START_SCREEN()',AllCaps(ScrStr)) = 1) OR
           (POS('~',ScrStr) = 1) OR
           (ScrStr[LENGTH(ScrStr)] = #13) OR
           (ScrStr[LENGTH(ScrStr)] = #10) OR
           (ScrStr[LENGTH(ScrStr)] = #2)) THEN BEGIN
          ScrStr := StripBoth(ScrStr,' ');
          ScrStr := StripBoth(ScrStr,#10);
          ScrStr := StripBoth(ScrStr,#13);
          ScrStr := StripBoth(ScrStr,#2);
          IF (DebugOn) AND (ScrStr <> '') THEN WRITELN(ScrStr);
          IF (ScrStr = #12) OR (AllCaps(ScrStr) = 'START_SCREEN()') OR (ScrStr = '~') THEN BEGIN
            IF DebugOn THEN OutTextXY(1,24,10,0,PadRight('Global Kill_Window() command received.',' ',79)) ELSE BEGIN
              TextActive := FALSE;
              MaxMode    := TRUE;
            END;
            ScreenDone := FALSE;
            IF (WindowNumber > 2) AND (NOT DebugOn) THEN REPEAT Kill_Window UNTIL WindowNumber = 2;
            UnloadGemFont(FPtr);
            Show_Mem;
            IF MouseOn THEN BEGIN
              HideMouse;
              MouseOn := FALSE;
            END;
            ScrStr := '';
          END;
          IF RipToText THEN BEGIN
            AnsiWindow;
            IF DebugOn THEN OutTextXY(1,24,12,0,PadRight('Host sent a "RIP to TEXT" mode command.',' ',79));
          END ELSE BEGIN
            IF POS('!|',ScrStr) = 0 THEN BEGIN
              IF (POS('MAXECUTE(',AllCaps(ScrStr)) = 1) OR (POS(#255#126#185,ScrStr) = 1) THEN WriteMaxInfoDef;
              IF (POS('SHOW_REMOTE_SCREEN(',AllCaps(ScrStr)) = 1) OR
                 (POS(#255#126#251,ScrStr) = 1) THEN DoRemoteScreen(ScrStr);
              IF POS(#255#126,ScrStr) = 1 THEN CheckControlLine(ScrStr) ELSE
              IF POS(#255#125,ScrStr) = 1 THEN CheckColorCommand(ScrStr) ELSE
              IF ScrStr <> '' THEN CheckScriptLine(ScrStr);
            END;
            ScrStr := '';
          END;
        END;
        IF (NOT MAXmode) AND (RipToText) THEN BEGIN
          ScrStr   := '';
          IF TextActive THEN CLRSCR ELSE CLR_SCR;
          IF DebugOn THEN OutTextXY(1,24,12,0,PadRight('Host sent a "RIP to TEXT" mode command.',' ',79));
        END;
        IF (NOT MAXmode) AND
           ((POS('START_SCREEN()',AllCaps(ScrStr)) = 1) OR
           (POS('~',ScrStr) = 1) OR
           (POS('[2!',ScrStr) = 1) OR
           (ScrStr[LENGTH(ScrStr)] = #13) OR
           (ScrStr[LENGTH(ScrStr)] = #10)) THEN BEGIN
          ScrStr := StripBoth(ScrStr,' ');
          ScrStr := StripBoth(ScrStr,#2);
          ScrStr := StripBoth(ScrStr,#10);
          ScrStr := StripBoth(ScrStr,#13);
          IF (ScrStr = #12) OR
             (POS('[2!',ScrStr) = 1) OR
             (AllCaps(ScrStr) = 'START_SCREEN()') OR
             (ScrStr = '~') THEN BEGIN
            IF NOT DebugOn THEN BEGIN
              IF TextActive THEN BEGIN
                RestartSvga;
                IF NOT MouseOn THEN HideMouse;
              END ELSE BEGIN
                Kill_Window;
                UnloadGemFont(FPtr);
                Show_Mem;
              END;
            END ELSE OutTextXY(1,24,10,0,PadRight('Host sent a "TEXT to SVGA" command.',' ',79));
            MAXmode    := TRUE;
            TextActive := FALSE;
          END;
          ScrStr := '';
        END;
      END;
      IF NOT MAXmode THEN BEGIN
        IF TextActive THEN DisplayANSI(MC) ELSE Display_ANSI(MC);
        IF (NOT DebugOn) AND (POS('|#|#|#',ScrStr) > 0) THEN BEGIN
          ScrStr := '';
          IF TextActive THEN DisplayANSIstr(#27'[2J') ELSE CLR_SCR;
        END;
      END;
      IF (MAXmode) AND (TvPort.Active) THEN BEGIN
        Display_ANSI(MC);
        IF (NOT DebugOn) AND (POS('|#|#|#',ScrStr) > 0) THEN BEGIN
          ScrStr := '';
          CLR_SCR;
        END;
      END;
    END;
  UNTIL Finished;
  IF ModPlaying THEN ModShutDown;
  ClearModem;
  IF (Carrier) AND (NOT AutoMode) THEN HangUp;
  DeInitComport;
  MouseOn := TRUE;
  IF TextActive THEN RestartSvga;
  IF WindowNumber > 1 THEN REPEAT Kill_Window UNTIL WindowNumber = 1;
  UnloadGemFont(FPtr);
  Show_Mem;
  ExplodeOn := FALSE;
  ResetTerminal;
END;

END.
